{*********************************}
  {Crditos-Autor}
  {* Criado por Vincius Magno *}
  {* E-mail magnolara@aol.com  *}
{*********************************}

unit MAbrevia;

interface

uses
  Windows, Messages, SysUtils, Classes;

type
  TMAbrevia = class(TComponent)
  private
    { Private declarations }
    FAboutAutor: String;
    FAboutRelease: String;
    FOriginal: string;
    FAbreviado: string;
    procedure SetAboutAutor(Value: string);
    procedure SetAboutRelease(Value: string);
    procedure SetAbreviado(Value: string);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override; published
    function AbreviaNome(Nome: String): String;
  published
    { Published declarations }
    property AboutAutor: String read FAboutAutor write SetAboutAutor;
    property AboutRelease: String read FAboutRelease write SetAboutRelease;
    property Original: string read FOriginal write SetAbreviado;
    property Abreviado: string read FAbreviado write FAbreviado;
  end;

procedure Register;

implementation

constructor TMAbrevia.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FAboutAutor := 'Vincius Magno Lara - magnolara@aol.com';
  FAboutRelease := '1.0 02/05/2003';
end;

function TMAbrevia.AbreviaNome(Nome: String): String;
var
  Nomes: array[1..20] of string;
  i, TotalNomes: Integer;
begin
  Nome := Trim(Nome);
  Result := Nome;
  {Insere um espao para garantir que todas as letras sejam testadas}
  Nome := Nome + #32;
  {Pega a posio do primeiro espao}
  i := Pos(#32, Nome);
  if i > 0 then
  begin
    TotalNomes := 0;
    {Separa todos os nomes}
    while i > 0 do
    begin
      Inc(TotalNomes);
      Nomes[TotalNomes] := Copy(Nome, 1, i - 1);
      Delete(Nome, 1, i);
      i := Pos(#32, Nome);
    end;
    if TotalNomes > 2 then
    begin
      {Abreviar a partir do segundo nome, exceto o ltimo.}
      for i := 2 to TotalNomes - 1 do
      begin
        {Contm mais de 3 letras? (ignorar de, da, das, do, dos, etc.)}
        if Length(Nomes[i]) > 3 then
          {Pega apenas a primeira letra do nome e coloca um ponto aps.}
           Nomes[i] := Nomes[i][1] + '.';
      end;
      Result := '';
      for i := 1 to TotalNomes do
        Result := Result + Trim(Nomes[i]) + #32;
        Result := Trim(Result);
      end;
    end;
end;

procedure TMAbrevia.SetAboutAutor(Value: string);
begin
  ;
end;

procedure TMAbrevia.SetAboutRelease(Value: string);
begin
  ;
end;

procedure TMAbrevia.SetAbreviado(Value: string);
begin
  FOriginal := value;
  FAbreviado := AbreviaNome(FOriginal);
end;

procedure Register;
begin
  RegisterComponents('MPack 2', [TMAbrevia]);
end;

end.
