{*********************************}

  {Crditos-Autor}
  {* Criado por Vincius Magno *}
  {* E-mail magnolara@aol.com  *}

{*********************************}

unit MCCard;

interface

uses
  Windows, Messages, SysUtils, Classes;

type
  TMCCard = class(TComponent)
  private
    { Private declarations }
    FAboutAutor: String;
    FAboutRelease: String;
    FNumeroCartao: String;
    FStatus: String;
    FValidade: Boolean;
    procedure SetNumeroCartao(Value: string);
    procedure SetAboutAutor(Value: string);
    procedure SetAboutRelease(Value: string);
  protected
    { Protected declarations }
    function VerificarCC(c: string): Integer;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override; published
  published
    { Published declarations }
    property NumeroCartao: string read FNumeroCartao write SetNumeroCartao;
    property Status: string read FStatus write FStatus;
    property Validade: boolean read FValidade write FValidade;
    property AboutAutor: String read FAboutAutor write SetAboutAutor;
    property AboutRelease: String read FAboutRelease write SetAboutRelease;
  end;

procedure Register;

implementation

constructor TMCCard.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FAboutAutor := 'Vincius Magno Lara - magnolara@aol.com';
  FAboutRelease := '1.0 02/05/2003';
end;

function TMCCard.VerificarCC(c: string): Integer;
var
  card: string[21];
  Vcard: array[0..21] of Byte absolute card;
  Xcard: Integer;
  Cstr: string[21];
  y, x: Integer;
begin
  Cstr := '';
  FillChar(Vcard, 22, #0);
  card := c;
  for x := 1 to 20 do
    if (Vcard[x] in [48..57]) then
      Cstr := Cstr + chr(Vcard[x]);
  card := '';
  card := Cstr;
  Xcard := 0;
  if not odd(Length(card)) then
    for x := (Length(card) - 1) downto 1 do
    begin
      if odd(x) then
        y := ((Vcard[x] - 48) * 2)
      else
        y := (Vcard[x] - 48);
      if (y >= 10) then
        y := ((y - 10) + 1);
      Xcard := (Xcard + y)
    end
  else
    for x := (Length(card) - 1) downto 1 do
    begin
      if odd(x) then
        y := (Vcard[x] - 48)
      else
        y := ((Vcard[x] - 48) * 2);
      if (y >= 10) then
        y := ((y - 10) + 1);
      Xcard := (Xcard + y)
    end;
  x := (10 - (Xcard mod 10));
  if (x = 10) then
    x := 0;
  if (x = (Vcard[Length(card)] - 48)) then
    Result := Ord(Cstr[1]) - Ord('2')
  else
    Result := 0
end;

procedure TMCCard.SetNumeroCartao(Value: String);
begin
  FNumeroCartao := Value;
  case VerificarCC(FNumeroCartao) of
    0: begin
         FStatus := 'Invalido ou Operadora desconhecida.';
         FValidade := false;
       end;
    1: begin
         FStatus := 'American Express';
         FValidade := true;
       end;
    2: begin
         FStatus := 'Visa';
         FValidade := true;
       end;
    3: begin
         FStatus := 'MasterCard';
         FValidade := true;
       end;
  end;
end;

procedure TMCCard.SetAboutAutor(Value: string);
begin
  ;
end;

procedure TMCCard.SetAboutRelease(Value: string);
begin
  ;
end;

procedure Register;
begin
  RegisterComponents('MPack 2', [TMCCard]);
end;

end.
