{*********************************}

  {Crditos-Autor}
  {* Criado por Vincius Magno *}
  {* E-mail magnolara@aol.com  *}

{*********************************}

unit MCNPJ;

interface

uses
  Windows, Messages, SysUtils, Classes;

type
  TMCNPJ = class(TComponent)
  private
    { Private declarations }
    FAboutAutor: String;
    FAboutRelease: String;
    FNumeroCNPJ: String;
    FValidade: Boolean;
    procedure SetNumeroCNPJ(Value: string);
    procedure SetAboutAutor(Value: string);
    procedure SetAboutRelease(Value: string);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override; published
  published
    { Published declarations }
    property NumeroCNPJ: string read FNumeroCNPJ write SetNumeroCNPJ;
    property Validade: boolean read FValidade write FValidade;
    property AboutAutor: String read FAboutAutor write SetAboutAutor;
    property AboutRelease: String read FAboutRelease write SetAboutRelease;
  end;

procedure Register;

implementation

constructor TMCNPJ.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FAboutAutor := 'Vincius Magno Lara - magnolara@aol.com';
  FAboutRelease := '1.0 02/05/2003';
end;

function ValidarCnpj(xCNPJ: String):Boolean;
Var
  d1,d4,xx,nCount,fator,resto,digito1,digito2 : Integer;
  Check : String;
begin
  d1 := 0;
  d4 := 0;
  xx := 1;
  for nCount := 1 to Length( xCNPJ )-2 do
  begin
    if Pos( Copy( xCNPJ, nCount, 1 ), '/-.' ) = 0 then
    begin
      if xx < 5 then
        fator := 6 - xx
      else fator := 14 - xx;
      d1 := d1 + StrToInt( Copy( xCNPJ, nCount, 1 ) ) * fator;
      if xx < 6 then
        fator := 7 - xx
      else begin
        fator := 15 - xx;    end;
        d4 := d4 + StrToInt( Copy( xCNPJ, nCount, 1 ) ) * fator;
        xx := xx+1;
      end;
   end;
   resto := (d1 mod 11);
   if resto < 2 then
     digito1 := 0
   else digito1 := 11 - resto;
   d4 := d4 + 2 * digito1;
   resto := (d4 mod 11);
   if resto < 2 then
     digito2 := 0
   else digito2 := 11 - resto;
   Check := IntToStr(Digito1) + IntToStr(Digito2);

   if Check <> copy(xCNPJ,succ(length(xCNPJ)-2),2) then
     Result := False
   else Result := True;
end;

procedure TMCNPJ.SetNumeroCNPJ(Value: String);
begin
  FNumeroCNPJ := Value;
  FValidade := ValidarCnpj(FNumeroCNPJ);
end;

procedure TMCNPJ.SetAboutAutor(Value: string);
begin
  ;
end;

procedure TMCNPJ.SetAboutRelease(Value: string);
begin
  ;
end;

procedure Register;
begin
  RegisterComponents('MPack 2', [TMCNPJ]);
end;

end.
