{*********************************}

  {Crditos-Autor}
  {* Criado por Vincius Magno *}
  {* E-mail magnolara@aol.com  *}

{*********************************}

unit MCPF;

interface

uses
  Windows, Messages, SysUtils, Classes;

type
  TMCPF = class(TComponent)
  private
    { Private declarations }
    FAboutAutor: String;
    FAboutRelease: String;
    FNumeroCPF: String;
    FValidade: Boolean;
    procedure SetNumeroCPF(Value: string);
    procedure SetAboutAutor(Value: string);
    procedure SetAboutRelease(Value: string);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override; published
  published
    { Published declarations }
    property NumeroCPF: string read FNumeroCPF write SetNumeroCPF;
    property Validade: boolean read FValidade write FValidade;
    property AboutAutor: String read FAboutAutor write SetAboutAutor;
    property AboutRelease: String read FAboutRelease write SetAboutRelease;
  end;

procedure Register;

implementation

constructor TMCPF.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FAboutAutor := 'Vincius Magno Lara - magnolara@aol.com';
  FAboutRelease := '1.0 - 02/05/2003';
end;

function Limpa(x: String): String;
var
  Cont: Integer;
begin
  for Cont := 1 to Length(x) do
  begin
    if (x[Cont] <> '.') and
       (x[Cont] <> '-') then
      result := result + x[cont];
  end;
end;

function ValidarCPF(num: string): boolean;
var
   n1,n2,n3,n4,n5,n6,n7,n8,n9: integer;
   d1,d2: integer;
   digitado, calculado: string;
begin
  // Limpa campos
  num := limpa(num);

  n1 := StrToInt(num[1]);
  n2 := StrToInt(num[2]);
  n3 := StrToInt(num[3]);
  n4 := StrToInt(num[4]);
  n5 := StrToInt(num[5]);
  n6 := StrToInt(num[6]);
  n7 := StrToInt(num[7]);
  n8 := StrToInt(num[8]);
  n9 := StrToInt(num[9]);

  d1 := n9*2 + n8*3 + n7*4 + n6*5 + n5*6 + n4*7 + n3*8 + n2*9 + n1*10;
  d1 := 11 - (d1 mod 11);

  if d1 >= 10 then
    d1 := 0;
  d2 := d1*2 + n9*3 + n8*4 + n7*5 + n6*6 + n5*7 + n4*8 + n3*9 + n2*10 + n1*11;
  d2 := 11 - (d2 mod 11);
  if d2 >= 10 then
    d2 := 0;
  calculado := inttostr(d1) + inttostr(d2);
  digitado := num[10] + num[11];
  if calculado = digitado then
    Result := True
  else Result := False;
end;

procedure TMCPF.SetNumeroCPF(Value: String);
begin
  FNumeroCPF := Value;
  FValidade := ValidarCPF(FNumeroCPF);
end;

procedure TMCPF.SetAboutAutor(Value: string);
begin
  ;
end;

procedure TMCPF.SetAboutRelease(Value: string);
begin
  ;
end;

procedure Register;
begin
  RegisterComponents('MPack 2', [TMCPF]);
end;

end.
 