{*********************************}

  {Crditos-Autor}
  {* Criado por Vincius Magno *}
  {* E-mail magnolara@aol.com  *}

  {Agradecimentos}
  {* Elieser Morais dos Reis   *}
  {* Javier Tari Agullo        *}

{*********************************}

unit MDBGrid;

interface

uses
  Windows, Messages, SysUtils, Classes, TypInfo, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Grids, DBGrids, DB, DBTables;

type

  TCustomGridHack = class(TCustomGrid);
  TDrawFieldCellEvent = procedure (Sender: TObject; Field : TField;
    Var Color : TColor; Var Font : TFont; Row: longint) of object;
  TdbeNativeClick = Set Of (ncssShift, ncssCtrl, ncssAlt);
  TColumnClickEvent = procedure(Sender: TObject; Index: Integer;
                                Button: TMouseButton; ShiftState: TShiftState;X,Y:Integer) of object;
  TColumnClickSimpleEvent = procedure(Sender: TObject; Index: Integer;
                                      ShiftState: TShiftState;X,Y:Integer) of object;
  TChangeDrawingEvent = procedure(Sender: TObject;DataCol,DataRow:Integer;
                                  AState: TGridDrawState;var Highlighted:Boolean)
                                  of object;
  TgedmMemo = (gedmNo,gedmYes);
  TgedmGraphic = (gedgNo,gedgStretch,gedgAdjust);

  // Nova Classe Herdeira do (DBGrid)
  TMDBGrid = class(TDBGrid)
  private
    { Private declarations }
    //Double Color
    FDoubleColor: Boolean;
    FLineColor, FLineFontColor: TColor;
    FDrawFieldCellEvent : TDrawFieldCellEvent;
    FColumnClick: integer;
    FColumnClickControl: Boolean;
    FButton: TMouseButton;
    FShiftState: TShiftState;
    FOnColumnClick: TColumnClickEvent;
    FOnColumnLeftClick: TColumnClickSimpleEvent;
    FOnColumnRightClick: TColumnClickSimpleEvent;
    FOnColumnMiddleClick: TColumnClickSimpleEvent;
    FOnChangeDrawing : TChangeDrawingEvent;
    FNativeClick : TdbeNativeClick;
    FDrawMemo : TgedmMemo;
    FDrawGraphic : TgedmGraphic;
    FNewDefaultRowHeight : Integer;
    FRowSizingAllowed : Boolean;
    FAboutAutor: String;
    FAboutRelease: String;
    procedure SetRowSizingAllowed(Value:Boolean);
    procedure SetDoubleColor(Value: Boolean);
    procedure SetLineColor(Value: TColor);
    procedure SetLineFontColor(Value: TColor);
  protected
    { Protected declarations }

    // MultiLine
    procedure MouseDown(Button: TMouseButton; ShiftState: TShiftState;
      X, Y: Integer); override;
    procedure MouseMove(ShiftState: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; ShiftState: TShiftState;
      X, Y: Integer); override;
    function  HighlightCell(DataCol, DataRow: Integer; const Value: string;
      AState: TGridDrawState): Boolean; override;
    procedure DrawColumnCell(const Rect: TRect; DataCol: Integer;
      Column: TColumn; State: TGridDrawState); override;
    function GetDefaultRowHeight: Integer;
    procedure SetDefaultRowHeight(Value: Integer);
    procedure LayoutChanged; override;
    procedure RowHeightsChanged; override;
    procedure DoOnColumnClick(Sender: TObject;Index:Integer;Button: TMouseButton;
                   ShiftState:TShiftState;X,Y:Integer);         dynamic;
    procedure DoOnColumnLeftClick(Sender: TObject;Index:Integer;
                   ShiftState:TShiftState;X,Y:Integer);         dynamic;
    procedure DoOnColumnRightClick(Sender: TObject;Index:Integer;
                   ShiftState:TShiftState;X,Y:Integer);         dynamic;
    procedure DoOnColumnMiddleClick(Sender: TObject;Index:Integer;
                   ShiftState:TShiftState;X,Y:Integer);         dynamic;
    function GetCurrentColumn:Integer;

    // Double Color
    procedure DrawCell(ACol, ARow: Longint; ARect: TRect;AState: TGridDrawState); override;
    procedure Scroll(Distance: Integer); override;
  public
    { Public declarations }
    constructor Create(AOwner : TComponent); override;
    destructor  Destroy;                     override;
    property Canvas;
    property SelectedRows;
    property TopRow;
    property Row;
    procedure MouseToCell(X,Y:Integer; var ACol,ARow:Integer); dynamic;
  published
    { Published declarations }

    // MultiLine
    property GridLineWidth;
    property OnMouseDown;
    property OnMouseUp;
    property OnMouseMove;
    property NativeClick:TdbeNativeClick Read FNativeClick Write FNativeClick Default [];
    property DrawMemo:TgedmMemo read FDrawMemo write FDrawMemo default gedmYes;
    property DrawGraphic:TgedmGraphic read FDrawGraphic write FDrawGraphic default gedgAdjust;
    property DefaultRowHeight:Integer read GetDefaultRowHeight write SetDefaultRowHeight;
    property OnChangeDrawing:TChangeDrawingEvent read FOnChangeDrawing write FOnChangeDrawing;
    property OnColumnClick:TColumnClickEvent read FOnColumnClick write FOnColumnClick;
    property OnColumnLeftClick:TColumnClickSimpleEvent read FOnColumnLeftClick write FOnColumnLeftClick;
    property OnColumnRightClick:TColumnClickSimpleEvent read FOnColumnRightClick write FOnColumnRightClick;
    property OnColumnMiddleClick:TColumnClickSimpleEvent read FOnColumnMiddleClick write FOnColumnRightClick;
    property RowSizingAllowed:Boolean read FRowSizingAllowed write SetRowSizingAllowed default False;
    //property OnEditCellEvent:TOnEditCellEvent read FOnEditCellEvent write FOnEditCellEvent;
    property CurrentColumn:Integer read GetCurrentColumn;

    // Double Color
    property Align;
    property BorderStyle;
    property Color;
    property Columns stored False;
    property Ctl3D;
    property DataSource;
    property DefaultDrawing;
    property DragCursor;
    property DragMode;
    property Enabled;
    property FixedColor;
    property Font;
    property ImeMode;
    property ImeName;
    property Options;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property TitleFont;
    property Visible;
    property DoubleColor: Boolean read FDoubleColor write SetDoubleColor default False;
    property LineColor: TColor read FLineColor write SetLineColor default clBlack;
    property LineFontColor: TColor read FLineFontColor write SetLineFontColor default $00F5ECE2;
    property OnCellClick;
    property OnColEnter;
    property OnColExit;
    property OnColumnMoved;
    property OnDrawDataCell;
    property OnDrawColumnCell;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEditButtonClick;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnStartDrag;
    property OnTitleClick;
    property AboutAutor: String read FAboutAutor write FAboutAutor;
    property AboutRelease: String read FAboutRelease write FAboutRelease;
  end;

procedure Register;

implementation
var
  DrawBitmap: TBitmap;
  UserCount: Integer;

procedure UsesBitmap;
begin
  if UserCount = 0 then
    DrawBitmap := TBitmap.Create;
  Inc(UserCount);
end;

procedure ReleaseBitmap;
begin
  Dec(UserCount);
end;

function Max(X, Y: Integer): Integer;
begin
  Result := Y;
  if X > Y then
    Result := X;
end;

procedure WriteText(ACanvas: TCanvas; ARect: TRect; DX, DY: Integer;
  const Text: string; Alignment: TAlignment);
const
  AlignFlags : array [TAlignment] of Integer =
   ( DT_LEFT or DT_WORDBREAK or DT_EXPANDTABS or DT_NOPREFIX,
     DT_RIGHT or DT_WORDBREAK or DT_EXPANDTABS or DT_NOPREFIX,
     DT_CENTER or DT_WORDBREAK or DT_EXPANDTABS or DT_NOPREFIX );
var
  B, R: TRect;
  I, Left: Integer;
begin
  I := ColorToRGB(ACanvas.Brush.Color);
  if GetNearestColor(ACanvas.Handle, I) = I then
  begin
    case Alignment of
      taLeftJustify:
      left := ARect.left + DX;
      taRightJustify:
      left := ARect.Right - ACanvas.TextWidth(Text) - 3;
    else
      Left := ARect.Left + (ARect.Right - ARect.Left) shr 1
      - (ACanvas.TextWidth(Text) shr 1);
    end;
    ExtTextOut(ACanvas.Handle, Left, ARect.Top + DY, ETO_OPAQUE or
    ETO_CLIPPED, @ARect, PChar(Text), Length(Text), nil);
  end else
  begin
    with DrawBitmap, ARect do
    begin
      Width := Max(Width, Right - Left);
      Height := Max(Height, Bottom - Top);
      R := Rect(DX, DY, Right - Left - 1, Bottom - Top - 1);
      B := Rect(0, 0, Right - Left, Bottom - Top);
    end;
    with DrawBitmap.Canvas do
    begin
      Font := ACanvas.Font;
      Font.Color := ACanvas.Font.Color;
      Brush := ACanvas.Brush;
      Brush.Style := bsSolid;
      FillRect(B);
      SetBkMode(Handle, TRANSPARENT);
      DrawText(Handle, PChar(Text), Length(Text), R, AlignFlags[Alignment]);
    end;
   ACanvas.CopyRect(ARect, DrawBitmap.Canvas, B);
  end;
end;

constructor TMDBGrid.Create(AOwner : TComponent);
begin
  // Padro para Gerar Componente
  inherited Create(AOwner);

  // Double Color
  FDoubleColor := False;
  FLineColor := $00F5ECE2;
  FLineFontColor := clBlack;
  UsesBitmap;

  // MultiLine
  ControlStyle := ControlStyle + [csAcceptsControls,csDisplayDragImage];
  FColumnClickControl:=False;
  FDrawMemo:=gedmYes;
  FDrawGraphic:=gedgAdjust;
  FNativeClick:=[];
  FRowSizingAllowed:=False;

  FAboutAutor := 'Vincius Magno Lara - magnolara@aol.com';
  FAboutRelease := '1.0 - 12/12/2002';
end;

destructor TMDBGrid.Destroy;
begin
  ReleaseBitmap;
  inherited Destroy;
end;

procedure TMDBGrid.SetDoubleColor(Value: Boolean);
begin
  FDoubleColor := Value;
  Refresh;
end;

procedure TMDBGrid.SetLineColor(Value: TColor);
begin
  FLineColor := Value;
  Refresh;
end;

procedure TMDBGrid.SetLineFontColor(Value: TColor);
begin
  FLineFontColor := Value;
  Refresh;
end;

procedure TMDBGrid.DrawCell(ACol, ARow: Longint; ARect: TRect;
               AState: TGridDrawState);
var
  OldActive, Indicator: Integer;
  Highlight: Boolean;
  Value: string;
  DrawColumn: TColumn;
  FrameOffs: Byte;
  cl: TColor;
  fn: TFont;
begin
  if csLoading in ComponentState then
  begin
    Canvas.Brush.Color := Color;
    Canvas.FillRect(ARect);
    Exit;
  end;
  if (gdFixed in AState) and (ACol - IndicatorOffset < 0) then
  begin
    inherited DrawCell(ACol, ARow, ARect, AState);
    exit;
  end;
  if (dgTitles in Options) And (ARow = 0) then
  begin
    inherited DrawCell(ACol, ARow, ARect, AState);
    exit;
   end;

   if(dgTitles in Options) then
     Dec(ARow);

   Dec(ACol, IndicatorOffset);
   if (gdFixed in AState) and ([dgRowLines, dgColLines] * Options =
   [dgRowLines, dgColLines]) then
   begin
     InflateRect(ARect, -1, -1);
     FrameOffs := 1;
   end
   else FrameOffs := 2;

   with Canvas do
   begin
     DrawColumn := Columns[ACol];
     Font := DrawColumn.Font;
     Brush.Color := DrawColumn.Color;
     Font.Color  := DrawColumn.Font.Color;
   if FDoubleColor and Odd(ARow) then
   begin
     Brush.Color := FLineColor;
     Font.Color  := FLineFontColor;
   end;
   if (DataLink = nil) or not DataLink.Active then
     FillRect(ARect)
   else begin
     Value := '';
     OldActive := DataLink.ActiveRecord;
     try
       DataLink.ActiveRecord := ARow;
       if Assigned(DrawColumn.Field) then
       begin
         Value := DrawColumn.Field.DisplayText;
         if Assigned(FDrawFieldCellEvent) then
         begin
            cl := Brush.Color;
            fn := Font;
            FDrawFieldCellEvent(self, DrawColumn.Field, cl, fn, ARow);
            Brush.Color := cl;
            Font := fn;
         end;
       end;
       Highlight := HighlightCell(ACol, ARow, Value, AState);
       if Highlight and (not FDoubleColor) then
       begin
         Brush.Color := clHighlight;
         Font.Color := clHighlightText;
       end;
       if DefaultDrawing then
         DefaultDrawColumnCell(ARect, ACol, DrawColumn, AState);
       if Columns.State = csDefault then
         DrawDataCell(ARect, DrawColumn.Field, AState);
       DrawColumnCell(ARect, ACol, DrawColumn, AState);
     finally
     DataLink.ActiveRecord := OldActive;
     end;

     if DefaultDrawing and
        (gdSelected in AState) and
        ((dgAlwaysShowSelection in Options) or Focused) and not
        (csDesigning in ComponentState)and not
        (dgRowSelect in Options) and
        (UpdateLock = 0) and
        (ValidParentForm(Self).ActiveControl = Self) then
       Windows.DrawFocusRect(Handle, ARect);
    end;
  end;

  if (gdFixed in AState) and
    ([dgRowLines, dgColLines] * Options = [dgRowLines, dgColLines]) then
  begin
   InflateRect(ARect, 1, 1);
   DrawEdge(Canvas.Handle, ARect, BDR_RAISEDINNER, BF_BOTTOMRIGHT);
   DrawEdge(Canvas.Handle, ARect, BDR_RAISEDINNER, BF_TOPLEFT);
  end;
end;

procedure TMDBGrid.Scroll(Distance: Integer);
begin
  inherited Scroll(Distance);
  if FDoubleColor then
    Refresh;
end;

procedure TMDBGrid.SetRowSizingAllowed(Value:Boolean);
begin
  If Value<>FRowSizingAllowed Then Begin
    FRowSizingAllowed:=Value;
    If FRowSizingAllowed Then
      TCustomGridHack(Self).Options:=TCustomGridHack(Self).Options+[goRowSizing]
    Else
      TCustomGridHack(Self).Options:=TCustomGridHack(Self).Options-[goRowSizing];
  End
end;


procedure TMDBGrid.MouseToCell(X,Y:Integer; var ACol,ARow:Integer);
var
  Coord:TGridCoord;
begin
  Coord:=MouseCoord(X, Y);
  ACol:=Coord.X;
  ARow:=Coord.Y;
end;


procedure TMDBGrid.MouseDown(Button: TMouseButton;ShiftState:TShiftState; X,Y:Integer);
var
   ACol,
   ARow: Integer;
   TmpShift : TdbeNativeClick;
begin
   MouseToCell(X, Y, ACol, ARow);
   if (ARow=0) and (dgTitles in Options) then begin
     TmpShift:=[];
     If ssShift In ShiftState Then
       TmpShift:=TmpShift+[ncssShift];
     If ssCtrl In ShiftState Then
       TmpShift:=TmpShift+[ncssCtrl];
     If ssAlt In ShiftState Then
       TmpShift:=TmpShift+[ncssAlt];
     If FNativeClick=TmpShift Then
       inherited MouseDown(Button,ShiftState,X,Y)
     Else Begin
       FColumnClickControl:=True;
       FColumnClick:=ACol;
       FButton:=Button;
       FShiftState:=ShiftState;
     end
    End
   Else begin
     FColumnClickControl:=False;
     Inherited;
   end
end;

procedure TMDBGrid.MouseMove(ShiftState: TShiftState; X, Y: Integer);
var
  ACol,
  ARow: Integer;
begin
  inherited;
  if FColumnClickControl And (FColumnClick>=0) then begin
    MouseToCell(X, Y, ACol, ARow);
    if (ACol<>FColumnClick) or (ARow<>0) then
      FColumnClickControl:=False;
  end;
end;

procedure TMDBGrid.MouseUp(Button: TMouseButton; ShiftState:TShiftState; X,Y:Integer);
var
  ACol,
  ARow: Integer;
begin
  inherited;
  MouseToCell(X, Y, ACol, ARow);
  if FColumnClickControl And (FColumnClick=ACol) then begin
    if dgIndicator in Options then
      Dec(FColumnClick);
    if (FColumnClick>=-1) then begin
      DoOnColumnClick(self, FColumnClick, Button, FShiftState, X,Y);
      If (FButton=mbLeft) then
        DoOnColumnLeftClick(self, FColumnClick, FShiftState, X,Y);
      If (FButton=mbRight) then
        DoOnColumnRightClick(self, FColumnClick, FShiftState, X,Y);
      If (FButton=mbMiddle) then
        DoOnColumnMiddleClick(self, FColumnClick, FShiftState, X,Y);
    end;
    FColumnClickControl:=False;
  end;
end;

procedure TMDBGrid.DoOnColumnClick(Sender: TObject;Index:Integer;Button: TMouseButton;ShiftState:TShiftState;X,Y:Integer);
begin
  If Assigned(FOnColumnClick) then
    FOnColumnClick(self, FColumnClick, Button, FShiftState, X,Y);
end;

procedure TMDBGrid.DoOnColumnLeftClick(Sender: TObject;Index:Integer;ShiftState:TShiftState;X,Y:Integer);
begin
  If Assigned(FOnColumnLeftClick) then
    FOnColumnLeftClick(self, FColumnClick, FShiftState, X,Y);
end;

procedure TMDBGrid.DoOnColumnRightClick(Sender: TObject;Index:Integer;ShiftState:TShiftState;X,Y:Integer);
begin
  If Assigned(FOnColumnRightClick) then
    FOnColumnRightClick(self, FColumnClick, FShiftState, X,Y);
end;

procedure TMDBGrid.DoOnColumnMiddleClick(Sender: TObject;Index:Integer;ShiftState:TShiftState;X,Y:Integer);
begin
  If Assigned(FOnColumnMiddleClick) then
    FOnColumnMiddleClick(self, FColumnClick, FShiftState, X,Y);
end;


function TMDBGrid.GetDefaultRowHeight:Integer;
begin
  Result:=Inherited DefaultRowHeight;
end;

procedure TMDBGrid.SetDefaultRowHeight(Value: Integer);
begin
  If Value=0 Then
    Value:=inherited DefaultRowHeight;
  inherited DefaultRowHeight:=Value;
  FNewDefaultRowHeight:=Value;
  if dgTitles in Options then begin
    Canvas.Font:=TitleFont;
    RowHeights[0]:=Canvas.TextHeight('Wg')+4;
  end;
end;

procedure TMDBGrid.LayoutChanged;
begin
  Inherited;
  SetDefaultRowHeight(FNewDefaultRowHeight);
end;

procedure TMDBGrid.RowHeightsChanged;
var
  i,ThisHasChanged,Def : Integer;
begin
  ThisHasChanged:=-1;
  Def:=DefaultRowHeight;
  For i:=Ord(dgTitles In Options) to RowCount Do
    If RowHeights[i]<>Def Then Begin
      ThisHasChanged:=i;
      Break;
    End;
  If ThisHasChanged<>-1 Then Begin
    SetDefaultRowHeight(RowHeights[ThisHasChanged]);
    RecreateWnd;
  End;
  inherited;
end;

function TMDBGrid.HighlightCell(DataCol, DataRow: Integer; const Value: string;
      AState: TGridDrawState): Boolean;
var
  Highlighted: Boolean;
begin
  Highlighted:=inherited HighlightCell(DataCol, DataRow, Value, AState);
  If Assigned(FOnChangeDrawing) Then
    FOnChangeDrawing(Self,DataCol,DataRow,AState,Highlighted);
  Result:=Highlighted;
end;

procedure TMDBGrid.DrawColumnCell(const Rect: TRect; DataCol: Integer;
  Column: TColumn; State: TGridDrawState);
var
  Bmp : TBitmap;
  R : TRect;
  FactorX,FactorY : Double;
  TmpWidth,TmpHeight : Integer;
  CWidth, CHeight : Integer;
  BWidth, BHeight : Integer;
begin
  If Assigned(DataSource) And Assigned(DataSource.DataSet) And DataSource.DataSet.Active Then Begin
    If Assigned(Column.Field) Then Begin
      If (Column.Field.DataType=ftMemo) Then Begin
        If FDrawMemo<>gedmNo Then Begin
          R:=Rect;
          Canvas.FillRect(R);
          Inc(R.Top,2);
          Inc(R.Left,2);
          DrawText(Canvas.Handle, PChar(Column.Field.AsString),
                     Length(Column.Field.AsString), R,
                     DT_WORDBREAK OR DT_NOPREFIX);
        End
       End
      Else If (Column.Field.DataType=ftGraphic) Then Begin
        Bmp:=TBitmap.Create;
        try
          Bmp.Assign(Column.Field);
          If FDrawGraphic=gedgAdjust Then Begin
            CWidth:=Rect.Right-Rect.Left+1-1;
            CHeight:=Rect.Bottom-Rect.Top+1-1;
            BWidth:=Bmp.Width;
            BHeight:=Bmp.Height;
            Try
              If BWidth=0 Then
                FactorX:=0
              Else
                FactorX:=CWidth/BWidth;
              If BHeight=0 Then
                FactorY:=0
              Else
                FactorY:=CHeight/BHeight;
            Except
              FactorX:=1;
              FactorY:=1;
            End;
            If FactorY<FactorX Then Begin
              TmpWidth:=Round(BWidth*FactorY);
              TmpHeight:=CHeight;
             End
            Else Begin
              TmpHeight:=Round(BHeight*FactorX);
              TmpWidth:=CWidth;
            End;
            SetRect(R, 0, 0, TmpWidth, TmpHeight);
            OffsetRect(R, Rect.Left+((CWidth - TmpWidth) div 2), Rect.Top+((CHeight - TmpHeight) div 2));
            Canvas.FillRect(Rect);
            Canvas.StretchDraw(R, Bmp);
           End
          Else Begin
            Canvas.StretchDraw(Rect,Bmp)
          End
        finally
          Bmp.Free;
        end
      End
    End;
  end;
  inherited;
end;

function TMDBGrid.GetCurrentColumn:Integer;
begin
  GetCurrentColumn:=RawToDataColumn(Col)
end;

procedure Register;
begin
  RegisterComponents('MPack 2', [TMDBGrid]);
end;

end.

