{*********************************}

  {Crditos-Autor}
  {* Criado por Vincius Magno *}
  {* E-mail magnolara@aol.com  *}

{*********************************}

unit MDataRot;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls;

type
  TMDataRot = class(TComponent)
  private
    { Private declarations }
    FDia: String;
    FMes: String;
    FAno: String;
    FData: String;
    FAboutAutor: String;
    FAboutRelease: String;
    procedure SetDia(Value: string);
    procedure SetMes(Value: string);
    procedure SetAno(Value: string);
    procedure SetData(Value: string);
    procedure SetAboutAutor(Value: string);
    procedure SetAboutRelease(Value: string);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override; published
  published
    { Published declarations }
    property Dia: String read FDia write SetDia;
    property Mes: String read FMes write SetMes;
    property Ano: String read FAno write SetAno;
    property Data: String read FData write SetData;
    Function DiaEscrito: String; virtual;
    Function MesEscrito(x: string): String; virtual;
    Function Hoje: String; virtual;
    Function DataArquivo(Arquivo: String): String; virtual;
    Function AnoBis(Data: TDateTime): Boolean; virtual;
    Function Idade(d: tDate): integer;
    Function ValidarData(D: String): Boolean; virtual;
    Function Comprimentar: String; virtual;
    property AboutAutor: String read FAboutAutor write SetAboutAutor;
    property AboutRelease: String read FAboutRelease write SetAboutRelease;
    procedure Atualiza;
  end;

procedure Register;

implementation

procedure TMDataRot.atualiza;
begin
  FDia := Copy(DateToStr(Date),1,2);
  FMes := Copy(DateToStr(Date),4,2);
  FAno := Copy(DateToStr(Date),7,4);
  FData := DateToStr(Date);
end;

procedure TMDataRot.SetDia(Value: String);
begin
  FDia := Copy(DateToStr(Date),1,2);
end;

procedure TMDataRot.SetMes(Value: String);
begin
  FMes := Copy(DateToStr(Date),4,2);
end;

procedure TMDataRot.SetAno(Value: String);
begin
  FAno := Copy(DateToStr(Date),7,4);
end;

procedure TMDataRot.SetData(Value: String);
begin
  FData := DateToStr(Date);
end;

Function TMDataRot.Comprimentar: String;
var
  Horario: Integer;
begin
  Horario := StrToInt(Copy(TimeToStr(Time),1,2));

  if (Horario >= 00) and
     (Horario <= 12) then
    Result := 'Bom dia'

  else if (Horario > 12) and
          (Horario <= 18) then
    Result := 'Boa tarde'

  else if (Horario > 18) and
          (Horario <= 24) then
    Result := 'Boa noite'
end;

constructor TMDataRot.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FAboutAutor := 'Vincius Magno Lara - magnolara@aol.com';
  FAboutRelease := '1.0 - 02/05/2003';
  Atualiza;
end;

procedure TMDataRot.SetAboutAutor(Value: string);
begin
  ;
end;

procedure TMDataRot.SetAboutRelease(Value: string);
begin
  ;
end;

Function TMDataRot.DataArquivo(Arquivo: String): String;
var
  FHandle: integer;
begin
  FHandle := FileOpen(Arquivo, 0);
  try
    Result := DateTimeToStr(FileDateToDateTime(FileGetDate(FHandle)));
  finally
   FileClose(FHandle);
  end;
end;

Function TMDataRot.ValidarData(D: String): Boolean;
begin
  try
    StrToDate(D);
  except
  on EConvertError do
    Result := False;
  end;
end;

Function TMDataRot.Idade(d: tDate): integer;
var
  nascA, nascM, nascD, hojeA, hojeM, hojeD: word;
  idade: integer;
label ResultIdade;
begin
  try
    // Decodifica datas do dia e do aniversrio do cidado
    DecodeDate(date, hojeA, hojeM, hojeD);
    DecodeDate(d, nascA, nascM, nascD);

    // Calcula ANO
    idade := hojeA - nascA;

    // Calcula MES
    if nascM < hojeM then
      goto resultIdade
    else if nascM = hojeM then
    begin
      if nascD < hojeD then
        dec(idade,1);
      goto resultIdade;
    end
    else if nascM > hojeM then
    begin
      dec(idade,1);
      goto resultIdade;
    end;

    // resultado
    resultIdade:
      result := idade;
  except end;
end;

Function TMDataRot.AnoBis(Data: TDateTime): Boolean;
var
  Dia,Mes,Ano : Word;
begin
  DecodeDate(Data,Ano,Mes,Dia);
  if Ano mod 4 <> 0 then
    AnoBis := False
  else
    if Ano mod 100 <> 0 then
      AnoBis := True
    else
      if Ano mod 400 <> 0 then
        AnoBis := False
      else
        AnoBis := True;
end;

Function TMDataRot.MesEscrito(x: string): String;
begin
  if x = '01' then Result := 'Janeiro'
  else if x = '02' then Result := 'Fevereiro'
  else if x = '03' then Result := 'Maro'
  else if x = '04' then Result := 'Abril'
  else if x = '05' then Result := 'Maio'
  else if x = '06' then Result := 'Junho'
  else if x = '07' then Result := 'Julho'
  else if x = '08' then Result := 'Agosto'
  else if x = '09' then Result := 'Setembro'
  else if x = '10' then Result := 'Outubro'
  else if x = '11' then Result := 'Novembro'
  else if x = '12' then Result := 'Dezembro'
end;

Function TMDataRot.DiaEscrito: String;
var
  dia: integer;
begin
  dia := DayOfWeek(date);
  case dia of
    1: result := 'Domingo';
    2: result := 'Segunda-feira';
    3: result := 'Tera-feira';
    4: result := 'Quarta-feira';
    5: result := 'Quinta-feira';
    6: result := 'Sexta-feira';
    7: result := 'Sbado';
  end;
end;

Function TMDataRot.Hoje: String;
begin
  Atualiza;
  Result := DiaEscrito + ', ' +
            Dia + ' de ' +
            MesEscrito(mes) + ' de ' +
            Ano;
end;

procedure Register;
begin
  RegisterComponents('MPack 2', [TMDataRot]);
end;

end.
