{*********************************}

  {Crditos-Autor}
  {* Criado por Vincius Magno *}
  {* E-mail magnolara@aol.com  *}

{*********************************}

unit MExeVInfo;

interface

uses
  Windows, Messages, SysUtils, Classes;

type
  TMExeVInfo = class(TComponent)
  private
    { Private declarations }
    FAboutAutor: String;
    FAboutRelease: String;
    FCompanyName: string;
    FFileDescription: string;
    FFileVersion: string;
    FInternalName: string;
    FLegalCopyright: string;
    FLegalTradeMarks: string;
    FOriginalFilename: string;
    FProductName: string;
    FProductVersion: string;
    FCommments: string;
    FAuthor: string;
    procedure SetAboutAutor(Value: string);
    procedure SetAboutRelease(Value: string);
  protected
    { Protected declarations }
    Versao : array [1..11] of String;
    procedure VerInfo;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override; published
  published
    { Published declarations }
    property AboutAutor: String read FAboutAutor write SetAboutAutor;
    property AboutRelease: String read FAboutRelease write SetAboutRelease;
    property Empresa: String read FCompanyName write FCompanyName;
    property ArquivoDescricao: String read FFileDescription write FFileDescription;
    property ArquivoVersao: String read FFileVersion write FFileVersion;
    property NomeInterno: String read FInternalName write FInternalName;
    property NomeOriginal: String read FOriginalFilename write FOriginalFilename;
    property NomeProduto: String read FProductName write FProductName;
    property Copyright: String read FLegalCopyright write FLegalCopyright;
    property TardeMarks: String read FLegalTradeMarks write FLegalTradeMarks;
    property VersaoProduto: String read FProductVersion write FProductVersion;
    property Comentarios: String read FCommments write FCommments;
    property Autor: String read FAuthor write FAuthor;
    procedure atualiza;
  end;

procedure Register;

implementation

procedure TMExeVInfo.VerInfo;
Const
 InfoStr : array [1..11] of String =
  ('CompanyName','FileDescription','FileVersion',
   'InternalName', 'LegalCopyright',
   'LegalTradeMarks','OriginalFilename',
   'ProductName','ProductVersion',
   'Commments', 'Author');
Var
   TamVer, i : Integer;
   Dummy : DWord;
   Tam : UINT;
   VerInfo : Pchar;
   Valor, Translation: Pointer;
   VerBegin : String;
begin
  TamVer := GetFileVersionInfoSize(Pchar(ParamStr(0)),Dummy);
  if TamVer > 0 then
  begin
    GetMem(VerInfo,TamVer);
    try
      GetFileVersionInfo(Pchar(ParamStr(0)),0,TamVer,VerInfo);
      VerQueryValue(VerInfo,'\\VarFileInfo\\Translation',Translation,Tam);
      VerBegin := '\\StringFileInfo\\'+
      IntToHex(LoWord(LongInt(Translation^)),4)+
      IntToHex(HiWord(LongInt(Translation^)),4)+'\\';

      for i := 1 to 11  do
        if VerQueryValue(VerInfo,PChar(VerBegin + InfoStr[i]),Valor,Tam) then
           if Tam > 0 then
             Versao[i] := String(Pchar(Valor));
    finally
      FreeMem(VerInfo,TamVer);
    end;
  end;
end;

procedure TMExeVInfo.atualiza;
begin
  // Carrega Info do aplicativo
  VerInfo;

  // Lana nas variaveis
  FCompanyName := Versao[1];
  FFileDescription := Versao[2];
  FFileVersion := Versao[3];
  FInternalName := Versao[4];
  FLegalCopyright := Versao[5];
  FLegalTradeMarks := Versao[6];
  FOriginalFilename := Versao[7];
  FProductName := Versao[8];
  FProductVersion := Versao[9];
  FCommments := Versao[10];
  FAuthor := Versao[11];
end;

constructor TMExeVInfo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FAboutAutor := 'Vincius Magno Lara - magnolara@aol.com';
  FAboutRelease := '1.0 - 02/05/2003';
  if not (csDesigning in ComponentState) then
    Atualiza  
end;

procedure TMExeVInfo.SetAboutAutor(Value: string);
begin
  ;
end;

procedure TMExeVInfo.SetAboutRelease(Value: string);
begin
  ;
end;

procedure Register;
begin
  RegisterComponents('MPack 2', [TMExeVInfo]);
end;

end.
