{*********************************}

  {Crditos-Autor}
  {* Criado por Vincius Magno *}
  {* E-mail magnolara@aol.com  *}

{*********************************}

unit MMsgDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls, forms;

type
  TMMsgDialog = class(TComponent)
  private
    { Private declarations }
    FTitulo: String;
    FMensagem: String;
    FTipo: Integer;
    FBtn: Integer;
    FAboutAutor: String;
    FAboutRelease: String;
    procedure SetAboutAutor(Value: string);
    procedure SetAboutRelease(Value: string);
    procedure SetMensagem(Value: string);
    procedure SetTitulo(Value: string);
    procedure SetTipo(Value: Integer);
    procedure SetBotoes(Value: Integer);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override; published
  published
    { Published declarations }
    property MessageText: String read FMensagem write SetMensagem;
    property Titulo: String read FTitulo write SetTitulo;
    property Tipo: Integer read FTipo write SetTipo;
    property Botoes: Integer read FBtn write SetBotoes;
    property AboutAutor: String read FAboutAutor write SetAboutAutor;
    property AboutRelease: String read FAboutRelease write SetAboutRelease;
    function Mensagem(Mensagem, Titulo : String; Imagem, Botoes : Integer) :Integer;
  end;

procedure Register;

implementation
uses MMsgDialogBox;

constructor TMMsgDialog.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FAboutAutor := 'Vincius Magno Lara - magnolara@aol.com';
  FAboutRelease := '1.0 - 02/05/2003';
end;

function TMMsgDialog.Mensagem(Mensagem, Titulo : String; Imagem, Botoes : Integer) :Integer;
begin
  // Atualiza Variaveis
  FMensagem := Mensagem;
  FTitulo := Titulo;
  FTipo := Imagem;
  FBtn := Botoes;

  // Cria Mensagem
  FrmBox := TFrmBox.Create(Application);
  FrmBox.LblTitulo.Caption := Titulo;
  FrmBox.LblTitulo2.Caption := Titulo;
  FrmBox.LBL_Mensagem.Caption := Mensagem;

  Case Imagem Of
    1 : FrmBox.IMG_Exclamation.Visible := True;
    2 : FrmBox.IMG_Information.Visible := True;
    3 : FrmBox.IMG_Question.Visible := True;
    4 : FrmBox.IMG_Stop.Visible := True;
  end;

  Case Botoes of
    1 : begin
          FrmBox.BIT_Sim.Caption := '&Ok';
          FrmBox.BIT_Sim.Left := 254;
          FrmBox.BIT_Nao.Visible := False;
          FrmBox.BIT_Cancelar.Visible := False;
        end;

    2 : begin
          FrmBox.BIT_Sim.Caption := '&Sim';
          FrmBox.BIT_Sim.Left := 173;
          FrmBox.BIT_Nao.Left := 254;
          FrmBox.BIT_Cancelar.Visible := False;
        end;
  end;
  FrmBox.ShowModal;

  // Pega click
  if FrmBox.Tag = 0 then Result := 1
  else if FrmBox.Tag = 1 then Result := 2
  else if FrmBox.Tag = 2 then Result := 3;

  FrmBox.Free;
end;

procedure TMMsgDialog.SetAboutAutor(Value: string);
begin
  ;
end;

procedure TMMsgDialog.SetAboutRelease(Value: string);
begin
  ;
end;

procedure TMMsgDialog.SetMensagem(Value: string);
begin
  FMensagem := value;
end;

procedure TMMsgDialog.SetTitulo(Value: string);
begin
  FTitulo := value;
end;

procedure TMMsgDialog.SetTipo(Value: Integer);
begin
  FTipo := value;
end;

procedure TMMsgDialog.SetBotoes(Value: Integer);
begin
  FBtn := value;
end;

procedure Register;
begin
  RegisterComponents('MPack 2', [TMMsgDialog]);
end;

end.
