{*********************************}

  {Crditos-Autor}
  {* Criado por Vincius Magno *}
  {* E-mail magnolara@aol.com  *}

{*********************************}

unit MTransparentForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Forms;

const
 WS_EX_LAYERED = $80000;
 LWA_COLORKEY = 1;
 LWA_ALPHA    = 2;

type
 TSetLayeredWindowAttributes = function
 (
   hwnd : HWND;
   crKey : TColor;
   bAlpha : byte;
   dwFlags : DWORD
 ): BOOL; stdcall;

type
  TMTransparentForm = class(TComponent)
  private
    { Private declarations }
    FAboutAutor: String;
    FAboutRelease: String;
    FActive: Boolean;
    FAlphaOut: Boolean;
    FAlphaIn: Boolean;
    FTransparencia: integer;
    procedure SetActive(Value: Boolean);
    procedure SetTransparencia(Value: integer);
    procedure SetAboutAutor(Value: string);
    procedure SetAboutRelease(Value: string);
  protected
    { Protected declarations }
    OwnerHandle: HWND;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override; published
  published
    { Published declarations }
    property Active: Boolean read FActive write SetActive;
    property Transparencia: integer read FTransparencia write SetTransparencia;
    property AboutAutor: String read FAboutAutor write SetAboutAutor;
    property AboutRelease: String read FAboutRelease write SetAboutRelease;
  end;

procedure Register;

implementation

constructor TMTransparentForm.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  OwnerHandle := (AOwner as TForm).Handle;
  FAboutAutor := 'Vincius Magno Lara - magnolara@aol.com';
  FAboutRelease := '1.0 - 02/05/2003';
  FActive := False;
  FAlphaOut := False;
  FAlphaIn := False;
  FTransparencia := 150;
end;

procedure SeTMTransparentForm(AHandle : THandle; AValue : byte = 0);
var
  Info: TOSVersionInfo;
  SetLayeredWindowAttributes: TSetLayeredWindowAttributes;
begin
  //Check Windows version
  Info.dwOSVersionInfoSize := SizeOf(Info);
  GetVersionEx(Info);
  if (Info.dwPlatformId = VER_PLATFORM_WIN32_NT) and
     (Info.dwMajorVersion >= 5) then
  begin
    SetLayeredWindowAttributes := GetProcAddress(GetModulehandle(user32), 'SetLayeredWindowAttributes');
    if Assigned(SetLayeredWindowAttributes) then
    begin
      SetWindowLong(AHandle, GWL_EXSTYLE, GetWindowLong(AHandle, GWL_EXSTYLE) or WS_EX_LAYERED);
      //Make form transparent
      SetLayeredWindowAttributes(AHandle, 0, AValue, LWA_ALPHA);
    end;
  end;
end;

procedure TMTransparentForm.SetTransparencia(Value: integer);
begin
  FTransparencia := Value;
  if not (csDesigning in ComponentState) and
     not (csLoading in ComponentState) and FActive then
    SeTMTransparentForm(OwnerHandle, FTransparencia);
end;

procedure TMTransparentForm.SetActive(Value: Boolean);
begin
  if FActive <> Value then
  begin
    FActive := Value;
    if not (csDesigning in ComponentState) and
       not (csLoading in ComponentState) and FActive then
    SeTMTransparentForm(OwnerHandle, FTransparencia);
  end
end;

procedure TMTransparentForm.SetAboutAutor(Value: string);
begin
  ;
end;

procedure TMTransparentForm.SetAboutRelease(Value: string);
begin
  ;
end;

procedure Register;
begin
  RegisterComponents('MPack 2', [TMTransparentForm]);
end;

end.
